#ifndef __HYDROFORTH__NUMBER_H__
#define __HYDROFORTH__NUMBER_H__

#include <stdbool.h>

extern bool hydroforth__number__is_digit(char c);

extern bool hydroforth__number__convert_hex_digit(char c, unsigned char *const val);

extern bool hydroforth__number__parse_number_hex(const char *const start, unsigned char len, int *const val);

extern bool hydroforth__number__parse_number(const char *const start, unsigned char len, int *const val);

typedef struct __HYDROFORTH__NUMBER
{
  bool (*is_digit)(char c);
  bool (*convert_hex_digit)(char c, unsigned char *const val);
  bool (*parse_number_hex)(const char *const start, unsigned char len, int *const val);
  bool (*parse_number)(const char *const start, unsigned char len, int *const val);
} __HYDROFORTH__NUMBER;

#endif
